// FullAccess
resource "azurerm_role_definition" "virtual_machines_fullaccess_definition" {
  name              = "virtual-machines-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Commerce/UsageAggregates/read",
      "Microsoft.Commerce/RateCard/read",
      "Microsoft.Compute/register/action",
      "Microsoft.Compute/unregister/action",
      "Microsoft.Compute/availabilitySets/read",
      "Microsoft.Compute/availabilitySets/write",
      "Microsoft.Compute/availabilitySets/delete",
      "Microsoft.Compute/availabilitySets/vmSizes/read",
      "Microsoft.Compute/virtualMachines/read",
      "Microsoft.Compute/virtualMachines/write",
      "Microsoft.Compute/virtualMachines/delete",
      "Microsoft.Compute/virtualMachines/start/action",
      "Microsoft.Compute/virtualMachines/powerOff/action",
      "Microsoft.Compute/virtualMachines/redeploy/action",
      "Microsoft.Compute/virtualMachines/restart/action",
      "Microsoft.Compute/virtualMachines/deallocate/action",
      "Microsoft.Compute/virtualMachines/generalize/action",
      "Microsoft.Compute/virtualMachines/capture/action",
      "Microsoft.Compute/virtualMachines/runCommand/action",
      "Microsoft.Compute/virtualMachines/convertToManagedDisks/action",
      "Microsoft.Compute/virtualMachines/performMaintenance/action",
      "Microsoft.Compute/virtualMachines/reimage/action",
      "Microsoft.Compute/virtualMachines/login/action",
      "Microsoft.Compute/virtualMachines/loginAsAdmin/action",
      "Microsoft.Compute/virtualMachines/instanceView/read",
      "Microsoft.Compute/virtualMachines/vmSizes/read",
      "Microsoft.Compute/images/read",
      "Microsoft.Compute/images/write",
      "Microsoft.Compute/images/delete",
      "Microsoft.Compute/restorePointCollections/read",
      "Microsoft.Compute/restorePointCollections/write",
      "Microsoft.Compute/restorePointCollections/delete",
      "Microsoft.Compute/restorePointCollections/restorePoints/read",
      "Microsoft.Compute/restorePointCollections/restorePoints/write",
      "Microsoft.Compute/restorePointCollections/restorePoints/delete",
      "Microsoft.Compute/restorePointCollections/restorePoints/retrieveSasUris/action",
      "Microsoft.Compute/virtualMachines/extensions/read",
      "Microsoft.Compute/virtualMachines/extensions/write",
      "Microsoft.Compute/virtualMachines/extensions/delete",
      "Microsoft.Compute/locations/vmSizes/read",
      "Microsoft.Compute/locations/operations/read",
      "Microsoft.Compute/locations/usages/read",
      "Microsoft.Compute/locations/runCommands/read",
      "Microsoft.Compute/operations/read",
      "Microsoft.Compute/skus/read",
      "Microsoft.Compute/disks/read",
      "Microsoft.Compute/disks/write",
      "Microsoft.Compute/disks/delete",
      "Microsoft.Compute/disks/beginGetAccess/action",
      "Microsoft.Compute/disks/endGetAccess/action",
      "Microsoft.Compute/snapshots/read",
      "Microsoft.Compute/snapshots/write",
      "Microsoft.Compute/snapshots/delete",
      "Microsoft.Compute/snapshots/beginGetAccess/action",
      "Microsoft.Compute/snapshots/endGetAccess/action",
      "Microsoft.Compute/locations/diskOperations/read",
      "Microsoft.Compute/sharedVMImages/read",
      "Microsoft.Compute/sharedVMImages/write",
      "Microsoft.Compute/sharedVMImages/delete",
      "Microsoft.Compute/sharedVMImages/versions/read",
      "Microsoft.Compute/sharedVMImages/versions/write",
      "Microsoft.Compute/sharedVMImages/versions/delete",
      "Microsoft.Compute/sharedVMImages/versions/replicate/action",
      "Microsoft.Compute/locations/capsOperations/read",
      "Microsoft.Compute/locations/publishers/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/skus/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/skus/versions/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/types/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/types/versions/read",
      "Microsoft.Compute/galleries/read",
      "Microsoft.Compute/galleries/write",
      "Microsoft.Compute/galleries/delete",
      "Microsoft.Compute/galleries/images/read",
      "Microsoft.Compute/galleries/images/write",
      "Microsoft.Compute/galleries/images/delete",
      "Microsoft.Compute/galleries/images/versions/read",
      "Microsoft.Compute/galleries/images/versions/write",
      "Microsoft.Compute/galleries/images/versions/delete",
      "Microsoft.Compute/locations/logAnalytics/getRequestRateByInterval/action",
      "Microsoft.Compute/locations/logAnalytics/getThrottledRequests/action",
      "Microsoft.Compute/hosts/read",
      "Microsoft.Compute/hosts/write",
      "Microsoft.Compute/hosts/delete",
      "Microsoft.Compute/hostGroups/read",
      "Microsoft.Compute/hostGroups/write",
      "Microsoft.Compute/hostGroups/delete",
      "Microsoft.Compute/proximityPlacementGroups/read",
      "Microsoft.Compute/proximityPlacementGroups/write",
      "Microsoft.Compute/proximityPlacementGroups/delete",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "virtual_machines_readonly_definition" {
  name              = "virtual-machines-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Commerce/UsageAggregates/read",
      "Microsoft.Commerce/RateCard/read",
      "Microsoft.Compute/availabilitySets/read",
      "Microsoft.Compute/availabilitySets/vmSizes/read",
      "Microsoft.Compute/virtualMachines/read",
      "Microsoft.Compute/virtualMachines/instanceView/read",
      "Microsoft.Compute/virtualMachines/vmSizes/read",
      "Microsoft.Compute/images/read",
      "Microsoft.Compute/restorePointCollections/read",
      "Microsoft.Compute/restorePointCollections/restorePoints/read",
      "Microsoft.Compute/virtualMachines/extensions/read",
      "Microsoft.Compute/locations/vmSizes/read",
      "Microsoft.Compute/locations/operations/read",
      "Microsoft.Compute/locations/usages/read",
      "Microsoft.Compute/locations/runCommands/read",
      "Microsoft.Compute/operations/read",
      "Microsoft.Compute/skus/read",
      "Microsoft.Compute/disks/read",
      "Microsoft.Compute/snapshots/read",
      "Microsoft.Compute/locations/diskOperations/read",
      "Microsoft.Compute/sharedVMImages/read",
      "Microsoft.Compute/sharedVMImages/versions/read",
      "Microsoft.Compute/locations/capsOperations/read",
      "Microsoft.Compute/locations/publishers/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/skus/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/skus/versions/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/types/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/types/versions/read",
      "Microsoft.Compute/galleries/read",
      "Microsoft.Compute/galleries/images/read",
      "Microsoft.Compute/galleries/images/versions/read",
      "Microsoft.Compute/hosts/read",
      "Microsoft.Compute/hostGroups/read",
      "Microsoft.Compute/proximityPlacementGroups/read",
    ]

    not_actions = [
      "Microsoft.Compute/register/action",
      "Microsoft.Compute/unregister/action",
      "Microsoft.Compute/availabilitySets/write",
      "Microsoft.Compute/availabilitySets/delete",
      "Microsoft.Compute/virtualMachines/write",
      "Microsoft.Compute/virtualMachines/delete",
      "Microsoft.Compute/virtualMachines/start/action",
      "Microsoft.Compute/virtualMachines/powerOff/action",
      "Microsoft.Compute/virtualMachines/redeploy/action",
      "Microsoft.Compute/virtualMachines/restart/action",
      "Microsoft.Compute/virtualMachines/deallocate/action",
      "Microsoft.Compute/virtualMachines/generalize/action",
      "Microsoft.Compute/virtualMachines/capture/action",
      "Microsoft.Compute/virtualMachines/runCommand/action",
      "Microsoft.Compute/virtualMachines/convertToManagedDisks/action",
      "Microsoft.Compute/virtualMachines/performMaintenance/action",
      "Microsoft.Compute/virtualMachines/reimage/action",
      "Microsoft.Compute/virtualMachines/login/action",
      "Microsoft.Compute/virtualMachines/loginAsAdmin/action",
      "Microsoft.Compute/images/write",
      "Microsoft.Compute/images/delete",
      "Microsoft.Compute/restorePointCollections/write",
      "Microsoft.Compute/restorePointCollections/delete",
      "Microsoft.Compute/restorePointCollections/restorePoints/write",
      "Microsoft.Compute/restorePointCollections/restorePoints/delete",
      "Microsoft.Compute/restorePointCollections/restorePoints/retrieveSasUris/action",
      "Microsoft.Compute/virtualMachines/extensions/write",
      "Microsoft.Compute/virtualMachines/extensions/delete",
      "Microsoft.Compute/disks/write",
      "Microsoft.Compute/disks/delete",
      "Microsoft.Compute/disks/beginGetAccess/action",
      "Microsoft.Compute/disks/endGetAccess/action",
      "Microsoft.Compute/snapshots/write",
      "Microsoft.Compute/snapshots/delete",
      "Microsoft.Compute/snapshots/beginGetAccess/action",
      "Microsoft.Compute/snapshots/endGetAccess/action",
      "Microsoft.Compute/sharedVMImages/write",
      "Microsoft.Compute/sharedVMImages/delete",
      "Microsoft.Compute/sharedVMImages/versions/write",
      "Microsoft.Compute/sharedVMImages/versions/delete",
      "Microsoft.Compute/sharedVMImages/versions/replicate/action",
      "Microsoft.Compute/galleries/write",
      "Microsoft.Compute/galleries/delete",
      "Microsoft.Compute/galleries/images/write",
      "Microsoft.Compute/galleries/images/delete",
      "Microsoft.Compute/galleries/images/versions/write",
      "Microsoft.Compute/galleries/images/versions/delete",
      "Microsoft.Compute/locations/logAnalytics/getRequestRateByInterval/action",
      "Microsoft.Compute/locations/logAnalytics/getThrottledRequests/action",
      "Microsoft.Compute/hosts/write",
      "Microsoft.Compute/hosts/delete",
      "Microsoft.Compute/hostGroups/write",
      "Microsoft.Compute/hostGroups/delete",
      "Microsoft.Compute/proximityPlacementGroups/write",
      "Microsoft.Compute/proximityPlacementGroups/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "virtual_machines_noaccess_definition" {
  name              = "virtual-machines-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Commerce/UsageAggregates/read",
      "Microsoft.Commerce/RateCard/read",
      "Microsoft.Compute/register/action",
      "Microsoft.Compute/unregister/action",
      "Microsoft.Compute/availabilitySets/read",
      "Microsoft.Compute/availabilitySets/write",
      "Microsoft.Compute/availabilitySets/delete",
      "Microsoft.Compute/availabilitySets/vmSizes/read",
      "Microsoft.Compute/virtualMachines/read",
      "Microsoft.Compute/virtualMachines/write",
      "Microsoft.Compute/virtualMachines/delete",
      "Microsoft.Compute/virtualMachines/start/action",
      "Microsoft.Compute/virtualMachines/powerOff/action",
      "Microsoft.Compute/virtualMachines/redeploy/action",
      "Microsoft.Compute/virtualMachines/restart/action",
      "Microsoft.Compute/virtualMachines/deallocate/action",
      "Microsoft.Compute/virtualMachines/generalize/action",
      "Microsoft.Compute/virtualMachines/capture/action",
      "Microsoft.Compute/virtualMachines/runCommand/action",
      "Microsoft.Compute/virtualMachines/convertToManagedDisks/action",
      "Microsoft.Compute/virtualMachines/performMaintenance/action",
      "Microsoft.Compute/virtualMachines/reimage/action",
      "Microsoft.Compute/virtualMachines/login/action",
      "Microsoft.Compute/virtualMachines/loginAsAdmin/action",
      "Microsoft.Compute/virtualMachines/instanceView/read",
      "Microsoft.Compute/virtualMachines/vmSizes/read",
      "Microsoft.Compute/images/read",
      "Microsoft.Compute/images/write",
      "Microsoft.Compute/images/delete",
      "Microsoft.Compute/restorePointCollections/read",
      "Microsoft.Compute/restorePointCollections/write",
      "Microsoft.Compute/restorePointCollections/delete",
      "Microsoft.Compute/restorePointCollections/restorePoints/read",
      "Microsoft.Compute/restorePointCollections/restorePoints/write",
      "Microsoft.Compute/restorePointCollections/restorePoints/delete",
      "Microsoft.Compute/restorePointCollections/restorePoints/retrieveSasUris/action",
      "Microsoft.Compute/virtualMachines/extensions/read",
      "Microsoft.Compute/virtualMachines/extensions/write",
      "Microsoft.Compute/virtualMachines/extensions/delete",
      "Microsoft.Compute/locations/vmSizes/read",
      "Microsoft.Compute/locations/operations/read",
      "Microsoft.Compute/locations/usages/read",
      "Microsoft.Compute/locations/runCommands/read",
      "Microsoft.Compute/operations/read",
      "Microsoft.Compute/skus/read",
      "Microsoft.Compute/disks/read",
      "Microsoft.Compute/disks/write",
      "Microsoft.Compute/disks/delete",
      "Microsoft.Compute/disks/beginGetAccess/action",
      "Microsoft.Compute/disks/endGetAccess/action",
      "Microsoft.Compute/snapshots/read",
      "Microsoft.Compute/snapshots/write",
      "Microsoft.Compute/snapshots/delete",
      "Microsoft.Compute/snapshots/beginGetAccess/action",
      "Microsoft.Compute/snapshots/endGetAccess/action",
      "Microsoft.Compute/locations/diskOperations/read",
      "Microsoft.Compute/sharedVMImages/read",
      "Microsoft.Compute/sharedVMImages/write",
      "Microsoft.Compute/sharedVMImages/delete",
      "Microsoft.Compute/sharedVMImages/versions/read",
      "Microsoft.Compute/sharedVMImages/versions/write",
      "Microsoft.Compute/sharedVMImages/versions/delete",
      "Microsoft.Compute/sharedVMImages/versions/replicate/action",
      "Microsoft.Compute/locations/capsOperations/read",
      "Microsoft.Compute/locations/publishers/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/skus/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/offers/skus/versions/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/types/read",
      "Microsoft.Compute/locations/publishers/artifacttypes/types/versions/read",
      "Microsoft.Compute/galleries/read",
      "Microsoft.Compute/galleries/write",
      "Microsoft.Compute/galleries/delete",
      "Microsoft.Compute/galleries/images/read",
      "Microsoft.Compute/galleries/images/write",
      "Microsoft.Compute/galleries/images/delete",
      "Microsoft.Compute/galleries/images/versions/read",
      "Microsoft.Compute/galleries/images/versions/write",
      "Microsoft.Compute/galleries/images/versions/delete",
      "Microsoft.Compute/locations/logAnalytics/getRequestRateByInterval/action",
      "Microsoft.Compute/locations/logAnalytics/getThrottledRequests/action",
      "Microsoft.Compute/hosts/read",
      "Microsoft.Compute/hosts/write",
      "Microsoft.Compute/hosts/delete",
      "Microsoft.Compute/hostGroups/read",
      "Microsoft.Compute/hostGroups/write",
      "Microsoft.Compute/hostGroups/delete",
      "Microsoft.Compute/proximityPlacementGroups/read",
      "Microsoft.Compute/proximityPlacementGroups/write",
      "Microsoft.Compute/proximityPlacementGroups/delete",
    ]
  }
}
